' save context and get return address

  ' Disable interrupts
  OldSR = SR
  SR    = SR or $E0

  ' save context in temporary variables
  asm
    ' save W0..W14
    mov  W0, CRTOS_TmpRegs               ' save W0
    mov  W1, CRTOS_TmpRegs + 2           ' save W1

    MOV     #lo_addr(W2), W0             ' save W2..W14 (W0 and W1 are used here)
    MOV     #lo_addr(CRTOS_TmpRegs), W1
    ADD     W1, #4, W1
    REPEAT  #12                          ' repeat 13 times
    mov     [W0++], [W1++]

    ' save PSVPAG, TBLPAG and RCOUNT
    mov PSVPAG, W0                       ' save PSVPAG
    mov W0, CRTOS_TmpRegs + 30

    mov TBLPAG, W0                       ' save TBLPAG
    mov W0, CRTOS_TmpRegs + 32

    mov RCOUNT, W0                       ' save RCOUNT
    mov W0, CRTOS_TmpRegs + 34

    ' save the return address (PCH and PCL)
    mov W15, W0                          ' StackPtr_ := ^word(W15)
    dec W0                               ' dec(StackPtr_)
    dec W0
    mov #lo_addr(CRTOS_TmpRegs), W1      ' temporary registers
    add #36, W1
    mov [W0--], [W1++]                   ' TmpPCH := StackPtr_^ dec (StackPtr_)
    mov [W0], [W1]                       ' TmpPCL := StackPtr_^
  end asm
  
  ' copy the temporary variables to the correct task
  W0 = @Taskdata[CurrentTask]            ' destination in task data
  asm
    mov #lo_addr(CRTOS_TmpRegs), W1      ' address of temporary registers
    REPEAT #19                           ' repeat 20 times
    mov [W1++], [W0++]
  end asm

  ' Enable Interrupts
  SR = OldSR
