' select next Ready task

  do
#IFDEF OS_ALWAYS
    if OS_AlwaysProcedure <> nil then OS_AlwaysProcedure^
    end if
#ENDIF
    Select_Next_Task
  loop until CurrentTask <> OS_NO_TASK

  ' disable interrupts
  OldSR = SR
  SR    = SR or $E0

  ' Change State
  TaskData[CurrentTask]._State = st_RUNNING   ' this task is running now

  ' restore context
  ' get the context into the temporary variables
  W0 = @TaskData[CurrentTask]
  asm
    mov #lo_addr(CRTOS_TmpRegs), W1           ' address of temporary registers
    repeat #19                                ' repeat 20 times
    mov [W0++], [W1++]

    ' restore the context in the processor registers
    MOV     #lo_addr(W2), W0                  ' restore W2..W14 (W0 and W1 are used here)
    MOV     #lo_addr(CRTOS_TmpRegs), W1
    ADD     W1, #4, W1
    REPEAT  #12                               ' repeat 13 times
    mov     [W1++], [W0++]

    mov CRTOS_TmpRegs + 30, W0                ' restore PSVPAG
    mov  W0, PSVPAG

    mov CRTOS_TmpRegs + 32, W0                ' restore TBLPAG
    mov W0, TBLPAG

    mov CRTOS_TmpRegs + 34, W0                ' restore RCOUNT
    mov W0, RCOUNT

    ' -------- place the return address on the stack (W0 and W1 are used here)
    mov W15, W0                               ' StackPtr_ := ^word(W15)
    dec W0                                    ' dec(StackPtr_)
    dec W0
    mov #lo_addr(CRTOS_TmpRegs), W1           ' StackPtr_^ := TmpPCH
    Add #36, W1
    mov [W1++], [W0--]                        ' dec(StackPtr_)
    mov [W1], [W0]                            ' StackPtr_^ := TmpPCL

    ' --------- restore W0 and W1 ------------
    mov CRTOS_TmpRegs, W0                     ' restore W0
    mov CRTOS_TmpRegs + 2, W1                 ' restore W1
  end asm

  ' enable interrupts
  SR = OldSr
